require 'dotenv'

Dotenv.load

module Diplo
  module Env
    module_function

    def fetch(variable)
      ENV["DIPLO_#{variable.to_s.upcase}"] || begin
        yield if block_given?
      end
    end

    def fetch_int(variable, error = nil, &block)
      fetch_converted variable, :Integer, error, &block
    end

    def fetch_float(variable, error = nil, &block)
      fetch_converted variable, :Float, error, &block
    end

    def fetch_converted(variable, conversion, error = nil)
      value = fetch(variable)
      return yield if value.nil? && block_given?

      send conversion, value
    rescue
      error ? raise(error) : raise
    end

  end
end